#include "date_in.h"
#include "callbacks.h"
#include <stdio.h>
#include <string.h>

/* Funzione di controllo della data 
 * Leave under GPL (C) Paolo Bongiorno 09/12/03
 * Tutti i diritti riservati */
int check_date(gchar data_char[60], GtkWidget *entry) 
  { gchar comando[200];
    gchar giorno[10];
    gchar mese[10];
    gchar anno[10];
    gchar anno_sys[10];
    gchar anno_trunc[10];
    gchar *date_val;
    PGresult *res;
    
    sprintf(giorno,"%c%c", data_char[0],data_char[1]);
    sprintf(mese,"%c%c", data_char[2],data_char[3]);
    sprintf(anno,"%c%c", data_char[4],data_char[5]); 

    sprintf(comando, "SELECT EXTRACT(year FROM current_date);" );
    res = PQexec(connessione,comando);
    sprintf(anno_sys,"%s",PQgetvalue(res, 0,0));
    sprintf(anno_trunc,"%c%c",anno_sys[2],anno_sys[3]);

    sprintf(comando, "SELECT (isfinite(date '%s-%s-%s'));",anno_sys,mese,giorno);
    res = PQexec(connessione,comando);
    date_val = PQgetvalue(res, 0,0);
    
    if (date_val == NULL || 0 != (strcmp(anno,anno_trunc)) )
      { gdk_beep();
	return 0;
      }
    else { sprintf(data_char, "%s/%s/%s",giorno,mese,anno);
           gtk_entry_set_text (GTK_ENTRY (entry), data_char);
	   return 1;
          }
  }
    
	  
