/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * COPYING NOTES
 * ____________
 *   lists_loader.c --  Quik lists loader 
 *
 *   Copyright (C) 2003 Dott. Paolo Bongiorno <p.bongy@tin.it>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 */

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * REVISION NOTES:
 *
 * RELEASED 15/10/03  by Dott. Paolo Bongiorno
 *
 */
/* =============================< lists_loader.c >================================*
 * COPYING NOTES
 * ____________
 * Quik list loader
 *
 *   Copyright (C) 2003 Dott. Paolo Bongiorno <p.bongy@tin.it>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 */

/* ==========================< REVISION NOTES >==============================*
 *
 * RELEASED 01/10/03  by Dott. Paolo Bongiorno
 *
 */
#include <gtk/gtk.h>
#include "lists_loader.h"
#include <string.h>
#include "callbacks.h"

int n_clear = 1;

void load_list(char *comando, GtkWidget *fin_padre, const char *fin_figlio)
{
  int i, n_tuple;
  PGresult *res;
  GtkWidget *list_item;
  GList *dlist = NULL;
  char *elemento = NULL;
  char str_ret[30];
  
     /* GtkWidget *list;  dichiarato globale */
     list = lookup_widget(fin_padre, fin_figlio);
     res = PQexec(connessione, comando);
     n_tuple = PQntuples(res);

     if ( n_tuple > n_clear) n_clear =  n_tuple;

     gtk_list_clear_items(GTK_LIST(list),0, n_clear);

            for (i = 0; i < n_tuple; i++) {
                    elemento = PQgetvalue(res, i,0);
                    sprintf(str_ret, "%d", i);
                    list_item = gtk_list_item_new_with_label(elemento);

                    gtk_object_set_data(GTK_OBJECT(list_item), "Return_Value",\
                                        strdup(str_ret));

                    dlist = g_list_append(dlist, list_item);
                    gtk_widget_show(list_item); 
                   } 
              gtk_list_append_items(GTK_LIST(list), dlist);
              list = NULL;
}
