/* =============================< clist_loader.c >================================*
 * COPYING NOTES
 * ____________
 * Quik clist loader
 *
 *   Copyright (C) 2003 Dott. Paolo Bongiorno <p.bongy@tin.it>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 */

/* ==========================< REVISION NOTES >==============================*
 *
 * RELEASED 01/10/03  by Dott. Paolo Bongiorno
 *
 */
#include <gtk/gtk.h>
#include "clist_loader.h"
#include "callbacks.h"


void load_clist(PGresult *res, gint n_tuple)
       {
	  gchar *elementi[n_tuple][4];
          GtkWidget *list = NULL;
          gint i, z;

  	  list = lookup_widget(Informatore, "clist2");
 	  gtk_clist_clear((GtkCList *)list);

          for (i = 0;  i < n_tuple; i++ ) {
               for (z = 0; z < 3; z++ )
                     elementi[i][z] = PQgetvalue(res, i,z);
              }
                     
          for ( i = 0 ; i < n_tuple ; i++ ) 
            gtk_clist_append( (GtkCList *) list, elementi[i]);
       }

