/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * COPYING NOTES
 * ____________
 *   combo_loader.c --  Quik combo loader 
 *
 *   Copyright (C) 2003 Dott. Paolo Bongiorno <p.bongy@tin.it>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 */

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * REVISION NOTES:
 *
 * RELEASED 15/10/03  by Dott. Paolo Bongiorno
 *
 */
#include <gtk/gtk.h>
#include <gtk/gtk.h>
#include "combo_loader.h"
#include "callbacks.h"


void load_combo(char *comando, GtkWidget *combo)
{
  int i, n_tuple;
  PGresult *res;
  GList *combo_list = NULL;
  char *elemento = NULL;

  res = PQexec(connessione, comando);
  n_tuple = PQntuples(res);

       for (i = 0; i < n_tuple; i++) {
              elemento = PQgetvalue(res, i,0);
              combo_list = g_list_append(combo_list, elemento);
            } 
        if (combo_list != NULL )
        gtk_combo_set_popdown_strings( GTK_COMBO(combo), combo_list);
}
